package flexpump;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.PreparedStatement;

import org.jdom.input.SAXBuilder;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import java.io.IOException;
import java.util.*;

/**
 * @author Leqo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FleXPump {
	Element rootElement;
//	Document jDomDocument
	Connection connection1;
	Connection connection2;
	XMLLanguageFileParser parser;
	
	void setConnection1(Connection c) {
		connection1=c;
	}
	
	void setConnection2(Connection c) {
		connection2=c;
	}
	
	Element getRootElement() {
		return rootElement;
	}
	
    public String readConfig(String filePath) {
        SAXBuilder builder = new SAXBuilder();
        
        try {
            Document doc = builder.build(filePath);
            rootElement = doc.getRootElement();
        }
        catch(IOException e) {
            System.out.println("Nenasiel sa subor");
			System.exit(-2);
        } catch (JDOMException e) {
            System.out.println("Nepodarilo sa buildnut subor");
			System.exit(-3);
        }
        
        return null;
    }

   
    private String findXMLElement(Element currentElement, String wantedElement) {
    	 String foundElementValue=null;
    	 String value=null;
         if(currentElement.getName() == wantedElement) {
            return currentElement.getValue();
         }
         
         List children = currentElement.getChildren();
         Iterator iterator = children.iterator();
         while (iterator.hasNext() && null==foundElementValue) {
           Element child = (Element) iterator.next();
           foundElementValue = findXMLElement(child, wantedElement);
         }
         return foundElementValue;
       }
    
    
    public static void main(String[] args) throws FleXPumpException {
    	if(args.length<2 || args[0].compareTo("/?")==0 || args[0].compareTo("--help")==0) {
    		System.out.println("Pouzivanie : \n/? alebo --help - tento vypis\n[cesta k XML config suboru] [cesta k XML language suboru] - spustenie pumpy");
    		System.exit(-1);
    	} 		
    	
		FleXPump pump = new FleXPump();
		pump.readConfig(args[0]);
		String url1 = pump.findXMLElement(pump.getRootElement(),"url1");
		String user1 = pump.findXMLElement(pump.getRootElement(),"user1");
		String password1 = pump.findXMLElement(pump.getRootElement(),"password1");
		String url2 = pump.findXMLElement(pump.getRootElement(),"url2");
		String user2 = pump.findXMLElement(pump.getRootElement(),"user2");
		String password2 = pump.findXMLElement(pump.getRootElement(),"password2");
//		System.out.println(url1);
//		System.out.println(user1);
//		System.out.println(password1);
//		System.out.println(url2);
//		System.out.println(user2);
//		System.out.println(password2);
		
    try {
      Class.forName("org.postgresql.Driver");
      pump.setConnection1(DriverManager.getConnection(url1, user1, password1));
      pump.setConnection2(DriverManager.getConnection(url2, user2, password2));
      
      pump.start(args[1]);
    } catch (ClassNotFoundException ex) {
    	System.out.println("FleXPump.FleXPump() - ClassNotFoundException - JDBC driver class not found");
        ex.printStackTrace();
    } catch (SQLException ex) {
    	System.out.println("FleXPump.FleXPump() - SQLException - connection creation error");
    	ex.printStackTrace();
    } catch (FleXPumpException e) {
    	System.out.println(e.getMessage());
		e.printStackTrace();
	} catch (XMLLanguageFileParserException e) {
    	System.out.println(e.getMessage());
		e.printStackTrace();
	}
  }

  private ResultSet executeQuery(String query) throws FleXPumpException {
    PreparedStatement stmt = null;
    try {
      stmt = connection1.prepareStatement(query);
      ResultSet rs = stmt.executeQuery();
      return rs;
    }
    catch (SQLException ex) {
      throw new FleXPumpException(
          "FleXPump.executeQuery() - statement creation error",ex);
    }

  }

  public void start(String XMLLanguageFilePath) throws FleXPumpException, XMLLanguageFileParserException, SQLException {

    ResultSet rs;
    PreparedStatement stmt1 = null;
    PreparedStatement stmt2 = null;
    parser = new XMLLanguageFileParser();

    try {
//      connection2.setAutoCommit(false);
    	
      stmt2 = connection2.prepareStatement("SELECT * FROM clear_database();");
      stmt2.executeQuery();
 
      rs = executeQuery("SELECT courses.id, courses.name FROM courses ORDER BY courses.id;");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_admitted_course VALUES(?,?);");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT approved_contest_ranks.id, approved_contests.name, approved_contest_ranks.name FROM approved_contest_ranks INNER JOIN approved_contests ON approved_contest_ranks.approved_contest_id = approved_contests.id ORDER BY approved_contest_ranks.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_approved_contest_rank VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2) + " " + rs.getString(3));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT countries.id, countries.legacy_id FROM countries ORDER BY countries.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_citizenship VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT countries.id, countries.name FROM countries ORDER BY countries.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_country VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT counties.id, counties.name FROM counties ORDER BY counties.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_county VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT degrees.id, degrees.name FROM degrees ORDER BY degrees.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_degree VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT disabilities.id, disabilities.name FROM disabilities ORDER BY disabilities.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_disability VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT education_types.id, education_types.name FROM education_types ORDER BY education_types.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_edu_type VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT exam_subjects.id, exam_subjects.name FROM exam_subjects ORDER BY exam_subjects.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_exam_subject VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT faculties.id, faculties.name FROM faculties ORDER BY faculties.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_faculty VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT genders.id, genders.name FROM genders ORDER BY genders.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_gender VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT marital_statuses.id, marital_statuses.name FROM marital_statuses ORDER BY marital_statuses.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_marital_status VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT nationalities.id, nationalities.name FROM nationalities ORDER BY nationalities.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_nationality VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT courses.id, courses.name FROM courses ORDER BY courses.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_prefered_course VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT prev_occupations.id, prev_occupations.name FROM prev_occupations ORDER BY prev_occupations.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_prev_occupation VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT ranked_contests.contest_id, approved_contests.name FROM ranked_contests INNER JOIN approved_contests ON ranked_contests.contest_id = approved_contests.id GROUP BY ranked_contests.contest_id, approved_contests.name ORDER BY ranked_contests.contest_id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_ranked_contest VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT schools.id, schools.name, schools.street, schools.city, schools.zip FROM schools ORDER BY schools.id");
      while (rs.next()) {
	String schoolName = rs.getString(2);
	if (!rs.getString(3).equals(""))
		schoolName = schoolName + ", " + rs.getString(3);
	if (!rs.getString(4).equals(""))
		schoolName = schoolName + ", " + rs.getString(4);
	if (!rs.getString(5).equals(""))
		schoolName = schoolName + " " + rs.getString(5);
        stmt2 = connection2.prepareStatement("INSERT INTO cis_school VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,schoolName);
        stmt2.executeUpdate();
      }

      rs = executeQuery(
          "SELECT school_types.id, school_types.name FROM school_types ORDER BY school_types.id");
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO cis_school_type VALUES(?,?)");
        stmt2.setInt(1,rs.getInt(1));
        stmt2.setString(2,rs.getString(2));
        stmt2.executeUpdate();
      }

      rs = executeQuery("SELECT public.applications.id, public.applications.degree_id, public.applications.faculty_id, public.applications.submit_stamp, public.applications.create_stamp, public.applications.admitted, public.applications.admitted_course_id, public.applications.state, public.applications.operator_added, public.undergraduate_applications.birth_date, public.undergraduate_applications.gender_id, public.undergraduate_applications.marital_status_id, public.undergraduate_applications.disability_id, public.undergraduate_applications.citizenship_id, public.undergraduate_applications.nationality_id, public.undergraduate_applications.county_id, public.undergraduate_applications.zip AS appzip, public.undergraduate_applications.edu_type_id, public.undergraduate_applications.country_id, public.undergraduate_applications.edu_completion_year, public.undergraduate_applications.edu_title, public.undergraduate_applications.prev_occupation_id, public.undergraduate_applications.school_id, public.undergraduate_applications.gpa1, public.undergraduate_applications.gpa2, public.undergraduate_applications.gpa3, public.undergraduate_applications.gpa4, public.undergraduate_applications.gpa5, public.undergraduate_applications.gpa_final, public.course_preferences.course_id, public.course_preferences.preference, public.exams.exam_subject_id, public.exams.result, public.schools.school_type_id, public.schools.zip, public.ranked_contests.contest_id, public.ranked_contests.rank_id, public.approved_contest_ranks.bonus, public.ranked_contests.accepted FROM (((((public.undergraduate_applications INNER JOIN public.applications ON public.undergraduate_applications.application_id=public.applications.id) LEFT JOIN public.course_preferences ON public.applications.id=public.course_preferences.application_id) LEFT JOIN public.exams ON public.applications.id=public.exams.application_id) INNER JOIN public.schools ON public.undergraduate_applications.school_id=public.schools.id) LEFT JOIN public.ranked_contests ON public.applications.id=public.ranked_contests.application_id) LEFT JOIN public.approved_contest_ranks ON public.ranked_contests.rank_id=public.approved_contest_ranks.id"

                        );
      while (rs.next()) {
        stmt2 = connection2.prepareStatement("INSERT INTO dat_stat_insert VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);");
        stmt2.setInt(1,rs.getInt("id"));
        stmt2.setInt(2,rs.getInt("degree_id"));
        stmt2.setInt(3,rs.getInt("faculty_id"));
        stmt2.setTimestamp(4,rs.getTimestamp("submit_stamp"));
        stmt2.setTimestamp(5,rs.getTimestamp("create_stamp"));
        stmt2.setBoolean(6,rs.getBoolean("admitted"));
        
        if(rs.getInt("admitted_course_id")==0)
        	stmt2.setNull(7, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(7,rs.getInt("admitted_course_id"));
        
        stmt2.setInt(8,rs.getInt("state"));
        stmt2.setBoolean(9,rs.getBoolean("operator_added"));
        stmt2.setTimestamp(10,rs.getTimestamp("birth_date"));
        
        if(rs.getInt("gender_id")==0)
        	stmt2.setNull(11, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(11,rs.getInt("gender_id"));

        if(rs.getInt("marital_status_id")==0)
        	stmt2.setNull(12, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(12,rs.getInt("marital_status_id"));
        
        if(rs.getInt("disability_id")==0)
        	stmt2.setNull(13, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(13,rs.getInt("disability_id"));

        if(rs.getInt("citizenship_id")==0)
        	stmt2.setNull(14, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(14,rs.getInt("citizenship_id"));

        stmt2.setInt(15,rs.getInt("nationality_id"));
        
        if(rs.getInt("county_id")==0)
        	stmt2.setNull(16, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(16,rs.getInt("county_id"));
        
        stmt2.setInt(17,0);

        stmt2.setString(18,rs.getString("appzip"));
        
        if(rs.getInt("edu_type_id")==0)
        	stmt2.setNull(19, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(19,rs.getInt("edu_type_id"));
        
        if(rs.getInt("country_id")==0)
        	stmt2.setNull(20, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(20,rs.getInt("country_id"));

        stmt2.setString(21,rs.getString("edu_completion_year"));
        stmt2.setString(22,rs.getString("edu_title"));
        
        if(rs.getInt("prev_occupation_id")==0)
        	stmt2.setNull(23, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(23,rs.getInt("prev_occupation_id"));

        stmt2.setInt(24,rs.getInt("school_id"));
        stmt2.setDouble(25,rs.getDouble("gpa1"));
        stmt2.setDouble(26,rs.getDouble("gpa2"));
        stmt2.setDouble(27,rs.getDouble("gpa3"));
        stmt2.setDouble(28,rs.getDouble("gpa4"));
        stmt2.setDouble(29,rs.getDouble("gpa5"));
        stmt2.setDouble(30,rs.getDouble("gpa_final"));
        stmt2.setInt(31,rs.getInt("course_id"));
        
        if(rs.getInt("preference")==0)
        	stmt2.setNull(32, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(32,rs.getInt("preference"));

        stmt2.setInt(33,rs.getInt("exam_subject_id"));
        stmt2.setInt(34,rs.getInt("result"));
        stmt2.setInt(35,rs.getInt("school_type_id"));
        stmt2.setString(36,rs.getString("zip"));
        
        if(rs.getInt("contest_id")==0)
        	stmt2.setNull(37, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(37,rs.getInt("contest_id"));

        if(rs.getInt("rank_id")==0)
        	stmt2.setNull(38, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(38,rs.getInt("rank_id"));
        
        if(rs.getInt("bonus")==0)
        	stmt2.setNull(39, java.sql.Types.INTEGER);
        else
        	stmt2.setInt(39,rs.getInt("bonus"));
        
        stmt2.setBoolean(40,rs.getBoolean("accepted"));

        stmt2.executeUpdate();  
      }
      parser.parseXML(XMLLanguageFilePath,connection2);
//      connection2.commit();
    }
    catch (SQLException ex1) {
//    	connection2.rollback();
    	throw new FleXPumpException("FleXPump.start() - SQLException",ex1);
    } catch (ClassNotFoundException e) {
//    	connection2.rollback();
    	throw new XMLLanguageFileParserException("XMLLanguageFileParser.parseXML - ClassNotFoundException",e);
	} catch (JDOMException e) {
//		connection2.rollback();
		throw new XMLLanguageFileParserException("XMLLanguageFileParser.parseXML - JDOMException",e);
	} catch (IOException e) {
//		connection2.rollback();
		throw new XMLLanguageFileParserException("XMLLanguageFileParser.parseXML - IOException",e);
	}

  }

  private void executeUpdate(String update, int connectionID) throws FleXPumpException {
    PreparedStatement stmt = null;
    try {
    	if(connectionID==1)
    		stmt = this.connection1.prepareStatement(update);
    	else
    		stmt = this.connection2.prepareStatement(update);
      stmt.executeUpdate();
    }
    catch (SQLException ex) {
      throw new FleXPumpException(
          "FleXPump.executeUpdate() - SQL error",ex);
    }
  }

  public void finalize() throws FleXPumpException {
    try {
      connection1.close();
      connection2.close();
    }
    catch (SQLException ex) {
      throw new FleXPumpException(
          "FleXPump.finalize() - connection closing error",ex);
    }

  }
}
